import java.awt.Color;
import java.lang.Math;

public class Antimony extends Iron
{
    public int choose(Color[] colors, int[] history, int place)
    {
	return oddOneOut(colors);
    }
    
    protected int oddOneOut(Color[] colors)
    {
	int i, j, localMin, pairedWith=1;
	int min=degrees, first=0, second=1;
	int index=0;
	
	for(i=0;i<colors.length;i++) {
	    localMin = degrees;
	    for(j=0;j<colors.length;j++) {
		if(i!=j) {
		    if(localMin > absDiff(colors[i],colors[j])) {
			localMin = absDiff(colors[i],colors[j]);
			pairedWith = j;
		    }
		}
	    }
	    
	    System.out.println("Crystal" + Integer.toString(i) + ": " + Integer.toString(convert(colors[i]))+ "\t" + Integer.toString(localMin) + "\t" + Integer.toString(intensity(colors[i])));
	    
	    if(localMin < min) {
		min = localMin;
		first = i;
		second = pairedWith;
	    }
	}
	
	if(intensity(colors[first]) > intensity(colors[second])) {
	    index = first;
	} else {
	    index = second;
	}
	
	System.out.println("Odd one out: " + Integer.toString(index));
	return index;
    }
    
    protected int intensity(Color color)
    {
	float[] hsv = new float[3];
	return Math.max(Math.max(color.getRed(), color.getGreen()), color.getBlue());
	//Color.RGBtoHSB(color.getRed(), color.getGreen(), color.getBlue(), hsv);
	//return Math.round(hsv[2]*1000);
    }
}