import java.awt.Color;
import java.lang.Math;

public class Iron extends AlgMine
{
    protected static int degrees = 360;
    
    public Iron()
    {
	mining = new Mining(this);
    }
    
    protected int oddOneOut(Color[] colors)
    {
	int i, j, tmp;
	int max=0, maxIndex=0;
	
	for(i=0;i<colors.length;i++) {
	    tmp = degrees;
	    for(j=0;j<colors.length;j++) {
		if(i!=j) {
		    if(tmp > absDiff(colors[i],colors[j])) {
			tmp = absDiff(colors[i],colors[j]);
		    }
		}
	    }
	    
	    System.out.println("Crystal" + Integer.toString(i) + ": " + Integer.toString(tmp));
	    
	    if(tmp > max) {
		max = tmp;
		maxIndex = i;
	    }
	}

	System.out.println("Odd one out: " + Integer.toString(maxIndex));
	return maxIndex;
    }
    
    protected int absDiff(Color a, Color b)
    {
	int d = Math.abs(convert(a)-convert(b));
	if(d > degrees/2) {
	    d = degrees - d;
	}
	return d;
    }
    
    protected int convert(Color color)
    {
	float[] hsv = new float[3];
	Color.RGBtoHSB(color.getRed(), color.getGreen(), color.getBlue(), hsv);
	return Math.round(hsv[0]*degrees);
    }
}