import java.awt.Color;
import java.lang.Math;

public abstract class AlgMine extends Macro
{
    protected Functions functions = new Functions();

    public void noInput()
    {
	mining.noInput();
    }
    
    public void setArgs(int[] args)
    {
	mining.setArgs(args);
    }
    
    public void run()
    {
	mining.run();
    }    
    
    protected int count=0;
    protected Mining mining;
    public int choose(Color[] colors, int[] history, int place)
    {
	int future;
	int result;
	
	future = oddOneOut(colors);
	
	history[((place-1) + history.length) % history.length] = future;
	
	String s = "";
	for(int i=0;i<history.length;i++) {
	    s += Integer.toString(history[i]);
	    s += " ";
	}
	s += ", " + Integer.toString(place);
	
	count++;
	if(count<history.length) {
	    result = future;
	} else {
	    result = history[place];
	}
	
	s += " => " + Integer.toString(result);
	System.out.println(s);
	
	return result;
    }
    
    abstract protected int oddOneOut(Color[] colors);
    abstract protected int convert(Color color);
}