import java.awt.Color;
import java.lang.Math;

public class Titanium extends Copper
{
    protected int[] unchanged = new int[Mining.NUMCRYSTALS];
    protected Color[] oldColors = new Color[Mining.NUMCRYSTALS];
    
    public Titanium()
    {
	int i;
	for(i=0;i<Mining.NUMCRYSTALS;i++) {
	    oldColors[i] = new Color(0,0,0);
	}
    }
    
    public int choose(Color[] colors, int[] history, int place)
    {
	int i;
	for(i=0;i<Mining.NUMCRYSTALS;i++) {
	    
	    System.out.println("Old Color: " + oldColors[i].toString() + "\tNew Color: " + colors[i].toString());
	    if(functions.compareColors(colors[i],oldColors[i])) {
		//if(colors[i] == oldColors[i]) {
		unchanged[i]++;
	    } else {
		unchanged[i]=0;
		oldColors[i] = colors[i];
	    }
	    System.out.println(unchanged[i]);
	}
	System.out.println("Picking: " + Integer.toString(indexOfMaxValue(unchanged)));
	return indexOfMaxValue(unchanged);
    }
    
    protected int indexOfMaxValue(int[] list)
    {
	int i, max=0, maxIndex=0;
	for(i=0;i<list.length;i++) {
	    if(list[i] >= max) {
		maxIndex = i;
		max = list[i];
	    }
	}
	
	return maxIndex;
    }
}